// MessServObj.cpp : Implementation of CMessServObj
#include "stdafx.h"
#include "MessSrv.h"
#include "MessServObj.h"
#include "..\QCClient\QCClient_i.c"

/*
   MSMQ    MQOA.tlh
no_implementation -   Wrapper   Smart-   MSMQ,
	       CComPtr - 
raw_interfaces_only -  VC++     MSMQ 
	  Wrapper 
raw_native_types -    / (_bstr_t, _variant_t) 
	    .       
	 CComBSTR  CComVariant
no_namespace -        MSMQ
*/
#import "D:\W2Kb3\System32\MQOA.DLL" no_implementation raw_interfaces_only raw_native_types no_namespace

/////////////////////////////////////////////////////////////////////////////
// CMessServObj

// smart -    -   
CComPtr <IMSMQQueueInfo> g_pQueueInfo;

/*	
   ,   ,     
      
*/
LPCTSTR g_CompNameArray[] = {_T("PC1"), _T("PC2"), _T("PC3")};

//  
const int CompArrSize = sizeof (g_CompNameArray)/sizeof (g_CompNameArray[0]);

/*
  smart-   
  ,   QC  DCOM 
*/
CComPtr <IQCReceiver> g_PtrArr[CompArrSize];

/*
  smart-   
MSMQ    MSMQ 
*/
CComPtr <IMSMQQueue> g_pQueueArr[CompArrSize];

CMessServObj::CMessServObj() {}

/*
Me Send -       
BSTR Text -    
SendMode Mode -   (SEND_QC_USE, SEND_MSMQ_USE, SEND_DCOM_USE) 
VARIANT_BOOL AutoPlay==True :
	 QC-    
	 DCOM-    
	  DCOM-  ( 
	 )
 AutoPlay==False :
 QC-     CALL RECORDER-
	 DCOM-    ,
	 DCOM-  
 MSMQ-  AutoPlay ,  
	    .
*/
STDMETHODIMP CMessServObj::Send (BSTR Text, SendMode Mode, VARIANT_BOOL AutoPlay)
{
	for (int i = 0; i < CompArrSize; i++) 
	{
		HRESULT hr = S_OK;
		if (g_PtrArr[i] == NULL) {
			switch (Mode)
			{
			case SEND_QC_USE: // QC
				{   
					// BIND_OPTS  ,   
					BIND_OPTS BO;
					BO.cbStruct = sizeof (BIND_OPTS);
					BO.dwTickCountDeadline = 0;
					BO.grfFlags = STGM_READWRITE;
					BO.grfMode = 0;
					
					// 
					TCHAR BindString[256];
					wsprintf(BindString, _T("queue:ComputerName=%s/new:QCClient.QCReceiver.1"), g_CompNameArray[i]);
					USES_CONVERSION;
					// QC 
					hr = CoGetObject(T2W(BindString), &BO, IID_IQCReceiver, (LPVOID*)&g_PtrArr[i]);
				}
				break;
			case SEND_DCOM_USE: // DCOM (RPC)
				{   
					// IID   
					MULTI_QI QI;
					memset (&QI, 0, sizeof (MULTI_QI));
					QI.pIID = &IID_IQCReceiver;
					
					//                  
					COSERVERINFO ServInfo;
					memset (&ServInfo, 0, sizeof (COSERVERINFO));
					USES_CONVERSION;
					ServInfo.pwszName = T2W(g_CompNameArray[i]);
					
					// DCOM 
					hr = CoCreateInstanceEx (CLSID_QCReceiver, NULL, CLSCTX_SERVER, &ServInfo, 1, &QI);
					
					if (SUCCEEDED (QI.hr))
						g_PtrArr[i].p = (IQCReceiver*)QI.pItf;
					else
						hr = QI.hr;
				}
				break;
			case SEND_MSMQ_USE: // MSMQ
				{   
					//Smart -  MSMQ 
					CComPtr <IMSMQMessage> g_pMessage;
					
					//  
					hr = g_pMessage.CoCreateInstance (__uuidof(MSMQMessage));
					
					if (SUCCEEDED (hr)) {
						//  
						hr = g_pMessage->put_Body (CComVariant (Text));
						
						// 
						if (SUCCEEDED (hr))
							hr = g_pMessage->Send (g_pQueueArr[i]);
					}
				}
				break;
			default:
				hr = E_INVALIDARG;
			}
		}
		if (FAILED (hr))
			continue;
		//  MSMQ     
		if (Mode == SEND_MSMQ_USE) 
			continue;
		
		// QC     CALL RECORDER,
		// DCOM         
		hr = g_PtrArr[i]->Send (Text);
		if (FAILED (hr))
			continue;
		
		/* QC      
		CALL RECORDER' QC ,
		 DCOM  -   
		*/
		if (AutoPlay)
			g_PtrArr[i].Release ();
	}
	return S_OK;
}

// Play -   
// CALL RECORDER'    QC ,\
//  DCOM -   
STDMETHODIMP CMessServObj::Play()
{
	for (int i = 0; i < CompArrSize; i++)
		g_PtrArr[i].Release ();
	
	return S_OK;
}

// MSMQTestInit -     
STDMETHODIMP CMessServObj::MSMQTestInit() 
{
	//     
	//       ,
	//    ,  ,   
	if (g_pQueueInfo == NULL) 
		g_pQueueInfo.CoCreateInstance (__uuidof(MSMQQueueInfo));
	HRESULT hr = S_OK;
	USES_CONVERSION;
	for (int i = 0; i < CompArrSize; i++)
	{
		//      -  ,
		// ,   
		if (g_pQueueArr[i] == NULL) {
			//  , Snt -   ,
			//MQTest_ -  ,
			TCHAR QueuePathName[256];
			wsprintf(QueuePathName, _T("snt\\MQTest_%s"), g_CompNameArray[i]);
			hr = g_pQueueInfo->put_PathName(CComBSTR(T2OLE(QueuePathName)));      
			// 
			hr = g_pQueueInfo->Open (MQ_SEND_ACCESS, MQ_DENY_NONE, &g_pQueueArr[i]);
			if (FAILED (hr)) {
				//  ,   
				hr = g_pQueueInfo->Create(&CComVariant (MQ_TRANSACTIONAL_NONE), &CComVariant (MQ_DENY_NONE));
				// 
				if (SUCCEEDED (hr))
					hr = g_pQueueInfo->Open (MQ_SEND_ACCESS, MQ_DENY_NONE, &g_pQueueArr[i]);
			}
		}
		//   ,   
		ATLASSERT (SUCCEEDED (hr));
	}
	return S_OK;
}
