// EventHelper.cpp : Implementation of CEventHelper
#include "stdafx.h"
#include "QCClient.h"
#include "EventHelper.h"

/////////////////////////////////////////////////////////////////////////////
// CEventHelper 

// MSMQEvent -     
CComPtr <IMSMQEvent> g_pEvent;

//  ,  ATL Wizard'
STDMETHODIMP CEventHelper::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IEventHelper
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

//    QCReceiver
STDMETHODIMP CEventHelper::Fire(BSTR Text)
{
	Fire_SetText(Text);
	return S_OK;
}

//   ,   
STDMETHODIMP CEventHelper::MSMQInit()
{
	HRESULT hr = S_OK;

	//     ,  
	//    
	if (m_pQueueInfo == NULL)
		::CoCreateInstance(CLSID_MSMQQueueInfo, NULL, CLSCTX_ALL, 
			IID_IMSMQQueueInfo, (void**)&m_pQueueInfo);

	//   ,  
	//   
	ATLASSERT (m_pQueueInfo);
	char ComputerName[256];
	DWORD Len = 255;

	GetComputerName (ComputerName, &Len);
	USES_CONVERSION;

	//    (snt -   )
	TCHAR QueuePathName[256];
	wsprintf (QueuePathName, _T("snt\\MQTest_%s"), ComputerName);
	hr = m_pQueueInfo->put_PathName(CComBSTR(T2OLE(QueuePathName)));
	ATLASSERT(SUCCEEDED(hr));
	
	//    -  
	//  ,  
	if (g_pEvent == NULL)
		::CoCreateInstance(CLSID_MSMQEvent, NULL, CLSCTX_ALL, 
			IID_IMSMQEvent, (void**)&g_pEvent);
	ATLASSERT(SUCCEEDED(hr));

	//     
	CComPtr<_DMSMQEventEvents> sp_DMSMQEventEvents;
	hr = QueryInterface(DIID__DMSMQEventEvents, (VOID**)&sp_DMSMQEventEvents);
	ATLASSERT(SUCCEEDED (hr));
	
	//    g_pEvent
	hr = AtlAdvise (g_pEvent, sp_DMSMQEventEvents, DIID__DMSMQEventEvents, &m_dw);
	ATLASSERT(SUCCEEDED (hr));

	//    ,  ,
	//   MSMQQueue
	m_pQueue.Release ();

	//   ,   
	hr = m_pQueueInfo->Open (MQ_RECEIVE_ACCESS, MQ_DENY_NONE, &m_pQueue);
	if (FAILED (hr)) {
		m_pQueueInfo->Create (&CComVariant (MQ_TRANSACTIONAL_NONE), &CComVariant (MQ_DENY_NONE));
		hr = m_pQueueInfo->Open (MQ_RECEIVE_ACCESS, MQ_DENY_NONE, &m_pQueue);
	}
	
	//  
	if (SUCCEEDED (hr))
		hr = m_pQueue->EnableNotification (g_pEvent, &CComVariant (MQMSG_FIRST), &CComVariant (-1));

	return hr;
}

// 
STDMETHODIMP CMSMQEventEvents::Invoke(DISPID dispidMember, REFIID riid,
	LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
	EXCEPINFO* pexcepinfo, UINT* puArgErr)
{
	CComPtr<IEventHelper> spIEventHelper;
	HRESULT hr = QueryInterface(IID_IEventHelper, (VOID**)&spIEventHelper);
	ATLASSERT(SUCCEEDED (hr));

	switch (dispidMember)
	{
	case 0: {	// _DMSMQEventEvents::Arrived
		ATLASSERT(VT_DISPATCH == pdispparams->rgvarg[1].vt && 
					VT_I4 == pdispparams->rgvarg[0].vt);

		//Smart -   
		CComPtr<IMSMQQueue> pQ;
		
		//      QueryInterface,
		//       IUnknown
		hr = pdispparams->rgvarg[1].pdispVal->QueryInterface (IID_IMSMQQueue, (VOID**)&pQ);
		ATLASSERT(SUCCEEDED (hr));
		
		//svMissing -  optional-
		CComVariant svMissing;
		svMissing.vt = VT_ERROR;

		CComVariant svTransaction(0, VT_ERROR);
		CComVariant svWantDestinationQueue(0, VT_ERROR);
		CComVariant svWantBody(0, VT_ERROR);
		CComVariant svReceiveTimeout(0, VT_ERROR);
		
		// 
		CComPtr<IMSMQMessage> spMessage;

		hr = pQ->ReceiveCurrent(&svTransaction, &svWantDestinationQueue, &svWantBody,
			&svReceiveTimeout, &spMessage);
		ATLASSERT(SUCCEEDED (hr));

		//  
		CComVariant svBody;
		hr = spMessage->get_Body(&svBody);
		ATLASSERT(SUCCEEDED (hr));
		
		//     
		spIEventHelper->Fire(svBody.bstrVal);

		//   
		pQ->EnableNotification (g_pEvent, &CComVariant (MQMSG_FIRST), &CComVariant (-1));
		ATLASSERT(SUCCEEDED (hr));
			}
		break;
	case 1: {	// _DMSMQEventEvents::ArrivedError
		ATLASSERT(VT_DISPATCH == pdispparams->rgvarg[2].vt && 
					VT_I4 == pdispparams->rgvarg[1].vt &&
					VT_I4 == pdispparams->rgvarg[0].vt);

		WCHAR ErrorDescr[256];
		swprintf (ErrorDescr, L"Error 0x%X", pdispparams->rgvarg[1].lVal);

		//     
		spIEventHelper->Fire (ErrorDescr);
			}
		break;
	}
	return S_OK;
}
