// EventHelper.h : Declaration of the CEventHelper

#ifndef __EVENTHELPER_H_
#define __EVENTHELPER_H_
#include "resource.h"       // main symbols
#include "QCClientCP.h"

//  MSMQ,   Microsoft VC++
#include <MQOAI.H>

// MSMQEvent -     
extern CComPtr <IMSMQEvent> g_pEvent;

/////////////////////////////////////////////////////////////////////////////
// CMSMQEventEvents -  -    MSMQEvent,
class ATL_NO_VTABLE CMSMQEventEvents : 	
	public IDispatchImpl<_DMSMQEventEvents, &DIID__DMSMQEventEvents, &LIBID_MSMQ> //MQOALib
{
	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
		LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
		EXCEPINFO* pexcepinfo, UINT* puArgErr);
};

/////////////////////////////////////////////////////////////////////////////
// CEventHelper
class ATL_NO_VTABLE CEventHelper : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CEventHelper, &CLSID_EventHelper>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CEventHelper>,
	public IDispatchImpl<IEventHelper, &IID_IEventHelper, &LIBID_QCClientLib>,
	public CMSMQEventEvents,
	public CProxy_IEventHelperEvents< CEventHelper >
{

public:
	CEventHelper() {}
	
DECLARE_CLASSFACTORY_SINGLETON(CEventHelper)
DECLARE_REGISTRY_RESOURCEID(IDR_EVENTHELPER)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CEventHelper)
	COM_INTERFACE_ENTRY(IEventHelper)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY2(IDispatch, IEventHelper)
	COM_INTERFACE_ENTRY_IID(DIID__DMSMQEventEvents, _DMSMQEventEvents)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CEventHelper)
	CONNECTION_POINT_ENTRY(DIID__IEventHelperEvents)
END_CONNECTION_POINT_MAP()

	HRESULT FinalConstruct()
	{
		// ,  ATL Vizard-
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		//    MSMQ 
		AtlUnadvise (g_pEvent, DIID__DMSMQEventEvents, m_dw);
		// ,  ATL Vizard-
		m_pUnkMarshaler.Release();
	}

	//,  ATL Vizard-
	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IEventHelper
public:
	//   MSMQ ,   
	STDMETHOD(MSMQInit)();

	//M Fire,    
	//  
	STDMETHOD(Fire)(/*[in]*/ BSTR Text);

private:
	//Smart -    -   
	CComPtr <IMSMQQueueInfo> m_pQueueInfo;

	//Smart -    - 
	CComPtr <IMSMQQueue> m_pQueue;

	//Cookie (),   AtlAdvise()
	// AtlUnadvise()
	DWORD m_dw;
};

#endif //__EVENTHELPER_H_
